function [T] = model_time(sensor, env, nu)

F=sensor.F;
rmax=sensor.rmax;
rho=sensor.rho;
dB=sensor.db;
sb=sensor.sb;
sr=sensor.sr;
ee=sensor.ee;
ef=sensor.ef;

delta=env.delta;
M=env.M;
d=env.d;

% E[o_{ab}] / T
p_obs=p_observed(sensor, env);
o_T=2*F*rho*(dB+sb)*p_obs/M^2;

% compute T required to obtain the desired E[nu]
p_inc = p_incorrect(sensor, env);
T = log(nu/M^2) / (-2*o_T*(0.5-p_inc)^2);